import os
from setuptools import setup, find_packages

def read(*rnames):
    return open(os.path.join(os.path.dirname(__file__), *rnames)).read()

name = 'zw.vogon'

setup(name=name,

      # Fill in project info below
      version='0.9',
      description="Evaluation application",
      long_description=(
        read('README.txt') +
        '\n\n' +
        read('src', 'zw', 'vogon', 'README.txt') +
        '\n\n' +
        read('CHANGES.txt')
        ),
      keywords='zope3 evaluation',
      author='Gregor Giesen',
      author_email='giesen@zaehlwerk.net',
      url='https://launchpad.net/zw.vogon',
      license='GPLv3',
      # Get more from http://www.python.org/pypi?%3Aaction=list_classifiers
      classifiers=['Development Status :: 3 - Alpha',
                   'Programming Language :: Python',
                   'Environment :: Web Environment',
                   'Topic :: Internet :: WWW/HTTP :: WSGI :: Application',
                   'Framework :: Zope3',
                   'Intended Audience :: Education',
                   'License :: OSI Approved :: GNU General Public License (GPL)',
                   ],

      packages=find_packages('src'),
      package_dir = {'': 'src'},
      namespace_packages=['zw'],
      include_package_data=True,
      zip_safe=False,
      extras_require = dict(
        app = ['zope.app.appsetup',
               'zope.app.authentication',
               'zope.app.component',
               'zope.app.container',
               'zope.app.error',
               'zope.app.form',
               'zope.app.publisher',
               'zope.app.publication',
               'zope.app.security',
               'zope.app.securitypolicy',
	       'zope.app.session',
               'zope.app.twisted',
               'zope.app.wsgi>=3.4.0',
               'zope.contentprovider',
               'zc.sourcerelease',
               ],
        test = ['zope.testing',
                'zope.app.testing',
                ],),
      install_requires = ['setuptools',
                          'zc.configuration==1.0',
                          # 'z3c.autoinclude',
                          
                          'pytz',
                          'rwproperty',


                          #Base packages
                          'ZODB3',
                          'ZConfig',
                          'zdaemon',
                          'zope.annotation',
                          'zope.contentprovider',
                          'zope.component',
			  'zope.deprecation',
                          'zope.dublincore',
                          'zope.filerepresentation',
                          'zope.formlib',
                          'zope.i18n',
                          'zope.interface',
                          'zope.modulealias',
                          'zope.publisher',
                          'zope.security',
                          'zope.securitypolicy',
                          'zope.sendmail',
                          'zope.traversing',
                          'zope.viewlet',
                          'zope.app.zcmlfiles',
                          'zope.app.appsetup',
                          'zope.app.authentication',
                          'zope.app.cache',
                          'zope.app.catalog',
                          'zope.app.component',
                          'zope.app.container',
                          'zope.app.error',
                          'zope.app.file',
                          'zope.app.form',
                          'zope.app.folder',
                          'zope.app.interface',
                          'zope.app.intid',
                          'zope.app.generations',
                          'zope.app.keyreference',
                          'zope.app.principalannotation',
                          'zope.app.publisher',
                          'zope.app.publication',
                          'zope.app.renderer',
                          'zope.app.security',
                          'zope.app.securitypolicy',
                          'zope.app.twisted',
                          'zope.app.wsgi>=3.4.0',
                          
                          'plone.i18n',
                          'pyExcelerator',
                          
                          'zc.sourcerelease',
                          'zc.resourcelibrary',
                          
                          'z3c.batching',
                          'z3c.breadcrumb',
                          'z3c.form',
                          'z3c.formui',
                          'z3c.layer.pagelet',
                          'z3c.macro',
                          'z3c.objpath',
                          'z3c.pagelet',
                          'z3c.schema',
                          'z3c.securitytool',
                          'z3c.template',
                          'z3c.traverser',
			  'z3c.viewlet',
                          'z3c.zrtresource',

                          'z3c.resourceinclude==0.3.0.1-zw0.1',

			  'ore.workflow', # BBB
                          
                          'zw.contentsform',
                          'zw.mail.incoming',
                          'zw.menu',
                          'zw.schema',
                          'zw.status',
                          'zw.widget',
                          ],
      )
