#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2007-2009 Gregor Giesen <vogon@zaehlwerk.net>             #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'

from zw.vogon.i18n import MessageFactory as _

from persistent import Persistent

from zope.component import adapter
from zope.event import notify
from zope.interface import implements
from zope.lifecycleevent import ObjectCreatedEvent
from zope.schema.fieldproperty import FieldProperty
from zope.app.container.contained import Contained
from zope.app.appsetup.bootstrap import getInformationFromEvent
from zope.app.appsetup.interfaces import IDatabaseOpenedWithRootEvent

from zw.vogon.app.interfaces import IApplicationSettings


class ApplicationSettings(Persistent, Contained):
    implements(IApplicationSettings)
    
    sender_address = FieldProperty(IApplicationSettings['sender_address'])
    admin_address = FieldProperty(IApplicationSettings['admin_address'])

    
@adapter(IDatabaseOpenedWithRootEvent)
def addApplicationSettings(event):
    db, conn, root, root_folder = getInformationFromEvent(event)
    sm = root_folder.getSiteManager()

    try:
        app_settings = sm['default']['vogon_settings']
    except KeyError:
        app_settings = ApplicationSettings()
        notify(ObjectCreatedEvent(app_settings))
        sm['default']['vogon_settings'] = app_settings
        sm.registerUtility(app_settings, IApplicationSettings)
    
