#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2007-2009 Gregor Giesen <vogon@zaehlwerk.net>             #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'

from zw.vogon.i18n import MessageFactory as _

from zope import schema

from zw.vogon.attribute import interfaces


class ICSSTemplate(interfaces.IAttributeTemplate):
    """Template for a CSS attribute.
    """

    default = schema.Text(
        title=_(u"Default Value"),
        description=_(u"""The field default value may be None or a legal
                        field value"""),
        required = False,
        )

    public = schema.Bool(
        title = _( u"Public" ),
        required = True,
        default = False )


class ICSS(schema.interfaces.IText, interfaces.IAttributeField):
    """Field containing an unicode string.
    """

