#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2007-2008 Gregor Giesen <vogon@zaehlwerk.net>             #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'

from zw.vogon.i18n import MessageFactory as _

from zope.annotation.attribute import AttributeAnnotations
from zope.event import notify
from zope.interface import directlyProvides
from zope.app.zopeappgenerations import getRootFolder
from zope.app.generations.utility import findObjectsProviding

from zw.vogon.question.control import interfaces

def evolve(context):
    """evolve to the new settings implementation
    """
    root = getRootFolder(context)

    for q in findObjectsProviding(root, interfaces.ICanControl):

        for ha in interfaces.IControllerQuestion(q).skip_items:
            try:
                data = AttributeAnnotations(ha.slave)['zw.vogon.question.controlled']
            except KeyError:
                continue
            slave = interfaces.IControlledQuestion(ha.slave)
            old = data.get('controller', None)
            if old is None or old == q:
                slave.controllers = set( [q] )
            else:
                slave.controllers = set( [old, q] ) 
        
            # Remove old attributes
            try:
                del ha.slave.__annotations__['zw.vogon.question.controlled']['controller']
            except:
                pass
        
