#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2007-2008 Gregor Giesen <vogon@zaehlwerk.net>             #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'

import zope.i18nmessageid 

MessageFactory = zope.i18nmessageid.MessageFactory('zw.vogon')

to_unicode = lambda string: \
    isinstance(string, unicode) and string or string.decode('utf-8')


umlaut_mapping = {
    u'\xe4': 'ae',
    u'\xf6': 'oe',
    u'\xfc': 'ue',
    u'\xc4': 'Ae',
    u'\xd6': 'Oe',
    u'\xdc': 'Ue',
    u'\xdf': 'ss' }

def umlaut_normalizer(string):
    string = to_unicode(string)
    for key,value in umlaut_mapping.items():
        string = string.replace(key,value)
    return string.encode('utf-8')
