#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2008 Gregor Giesen <vogon@zaehlwerk.net>                  #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'

from zw.vogon.i18n import MessageFactory as _

from zope.component import getUtility
from zope.component.interfaces import IFactory

from zope.viewlet.viewlet import ViewletBase
from zope.app.container.constraints import checkFactory
from zope.app.publisher.browser.menu import getMenu

from zw.vogon.layer import IVogonBrowserLayer


class AddingPortlet(object):
    
    def addingInfo(self):
        """Return menu data.

        This is sorted by title.
        """
        result = []
        for item in getMenu('zope.app.container.add', self.context, self.request):
            extra = item.get('extra')
            if False:
                factory = extra.get('factory')
                if factory:
                    factory = getUtility(IFactory, factory)
                    if not checkFactory(self.context, None, factory):
                        continue
                    elif item['extra']['factory'] != item['action']:
                        item['has_custom_add_view']=True
            result.append(item)

        result.sort(lambda a, b: cmp(a['title'], b['title']))
        return result
