#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2007-2008 Gregor Giesen <vogon@zaehlwerk.net>             #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'

from zw.vogon.i18n import MessageFactory as _

from zope.component import queryAdapter, queryUtility
from zope.interface import implements
from zope.schema.fieldproperty import FieldProperty
from zope.app.authentication.interfaces import IAuthenticatorPlugin
from zope.app.intid.interfaces import IIntIds

from zw.vogon.participant.interfaces import IParticipantAuthentication, \
    IParticipants


class ParticipantAuthenticationPlugin(object):
    implements(IParticipantAuthentication, IAuthenticatorPlugin)

    def authenticateCredentials(self, credentials):
        if not isinstance(credentials, dict):
            return None
        if not ('survey_id' in credentials and 'participant_id' in credentials):
            return None

        intids = queryUtility(IIntIds)
        if intids is None:
            return None

        survey_id = credentials.get('survey_id')
        participant_id = credentials.get('participant_id')

        survey = intids.queryObject(survey_id)
        if survey is None:
            return None

        participants = queryAdapter(survey, IParticipants)
        if participants is None:
            return

        return participants.authenticateParticipant(participant_id)
        
        
    def principalInfo(self, id):
        # We don't any searching capabilities
        pass


