#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2007-2008 Gregor Giesen <vogon@zaehlwerk.net>             #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'

from zw.vogon.i18n import MessageFactory as _


from zope.interface import implements
from zope.publisher.interfaces.http import IHTTPRequest
from zope.app.authentication.interfaces import ICredentialsPlugin

from zw.vogon.utils.b64 import urlsafe_b64decode
from zw.vogon.participant.interfaces import IParticipantCredentials

class ParticipantCredentials(object):
    implements(IParticipantCredentials, ICredentialsPlugin)

    def extractCredentials(self, request):
        """See ICredentialsPlugin.
        """
        if not IHTTPRequest.providedBy(request):
            return

        # extract id from request
        uid = request.get('uid', None)
        try:
            survey_id, participant_id = urlsafe_b64decode(str(uid)).split('_')

        except:
            return
        else:
            return { 'survey_id': int(survey_id),
                     'participant_id': participant_id }

                
    def challenge(self, request):
        pass

    def logout(self, request):
        pass
