#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2007-2008 Gregor Giesen <vogon@zaehlwerk.net>             #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'

from zw.vogon.i18n import MessageFactory as _

from zope.dublincore.interfaces import IZopeDublinCore
from zope.interface import implements, Interface
from zope.app.container.interfaces import IContained

from z3c.form import form

from zw.contentsform.adding import AddingFormMixin
from zw.contentsform.column import FieldColumn, ContentNameColumn, Columns
from zw.contentsform.contentsform import ContentsForm
from zw.contentsform.cutcopypaste import CutCopyPasteMixin, RenamableMixin

from zw.vogon.portal.interfaces import IPortal
#from zw.vogon.portal.browser.interfaces import IManagePortals

class IManagePortals(Interface):
    """Manage portals view.
    """

class ManagePortals(AddingFormMixin, CutCopyPasteMixin, RenamableMixin, 
                    ContentsForm):
    implements(IManagePortals)
    form.extends(AddingFormMixin, CutCopyPasteMixin, RenamableMixin)

    label = _( u'label-portal.browser.manage.ManagePortals.label',
               u"Portal management" )

    cssClasses = {'table': 'listing' }
    canCopy = False

    def getContents(self):
        return [ item for item in self.context.values() \
                     if IPortal.providedBy(item) ]
    
    
    def _getColumns(self):
        return Columns(
            ContentNameColumn( title=u'Name', action=u'' ),
            FieldColumn( IZopeDublinCore['title'], addable=False,
                         action=u'' ),
            FieldColumn( IZopeDublinCore['created'], addable=False ),
            )
