#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2007-2008 Gregor Giesen <vogon@zaehlwerk.net>             #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
Portal properties

$Id$
"""
__docformat__ = 'reStructuredText'

from zw.vogon.i18n import MessageFactory as _

from zope.traversing.browser import absoluteURL
from zope.app.component.hooks import getSite

from zw.vogon.portal.interfaces import IPortal

class PortalProperties(object):
    
    def inPortal(self):
        """Checks if we are in a portal.
        """
        site = getSite()
        if IPortal.providedBy(site):
            return True
        return False

    def portal_url(self):
        """Returns the absolute url of the portal.
        """
        site = getSite()
        if IPortal.providedBy(site):
            return absoluteURL( site, self.request )
        
