#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2007-2008 Gregor Giesen <vogon@zaehlwerk.net>             #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'

from zw.vogon.i18n import MessageFactory as _

from zope import schema
from zope.component.interfaces import IObjectEvent
from zope.interface import Interface

from zope.annotation.interfaces import IAttributeAnnotatable
from zope.app.component.interfaces import IPossibleSite
from zope.app.container.interfaces import IContainer, IContained
from zope.app.container.constraints import contains, containers

class IPortal(IContained, IAttributeAnnotatable):
    """A portal contains a single isolated evaluation system.
    """
    title = schema.TextLine(
        title = _( u'label-portal.IPortal.title',
                   u"Title" ),
        description = _( u'help-portal.IPortal.title',
                         u"A short portal name." ),
        required = True 
        )

class IPortalContainer(IContainer, IPossibleSite):
    """The container part of an IEvaluationSite.
    """

class INewPortalEvent(IObjectEvent):
    """A new evaluation portal has been created.
    """

class INewCatalogEvent(IObjectEvent):
    """A new catalog of the evaluation portal has been created.
    """
