#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2008 Gregor Giesen <vogon@zaehlwerk.net>                  #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'

from zw.vogon.i18n import MessageFactory as _

from zope import schema
from zope.interface import Interface

from zw.schema.richtext import RichText

class IPortalSettings(Interface):
    """Customize the portals title, etc.
    """

    title = schema.TextLine(
        title = _( u'label-portal.settings.IPortalSettings.title',
                   u"Title" ),
        description = _( u'help-portal.settings.IPortalSettings.title', 
                         u"Enter the titel of the evaluation portal." ),
        required = True )
        
    base_url = schema.URI(
        title = _( u'label-portal.settings.IPortalSettings.base_url',
                   u"Base URL" ),
        description = _( u'help-portal.settings.IPortalSettings.base_url',
                         u"Enter the root URL of the portal (e.g. for "
                         u"SSL proxies, etc.) or leave blank." ),
        required = False )



class IFrontPage(Interface):
    """Customize the start page of the portal for the anonymous user.
    """

    body = RichText(
        title = _( u'label-portal.settings.IFrontPage.body',
                   u"Body" ),
        description = _( u'help-portal.settings.IFrontPage.body', 
                         u"Enter HTML text to be rendered for the front page." ),
        required = True )


