#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2007-2008 Gregor Giesen <vogon@zaehlwerk.net>             #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'

from zw.vogon.i18n import MessageFactory as _

from zope.annotation.interfaces import IAnnotations
from zope.component import adapter, getUtility
from zope.interface import implements, implementer
from zope.traversing.api import getParent
from zope.app.authentication.interfaces import IPrincipal, IPrincipalInfo
from zope.app.authentication.principalfolder import IInternalPrincipal
from zope.app.principalannotation.interfaces import IPrincipalAnnotationUtility

from zw.vogon.principal.interfaces import IPerson
from zw.vogon.utils.mapping import AnnotationsMapper, MappingFieldProperty

KEY = 'zw.vogon.principal.person'

# Person = AnnotationsMapperClass('Person', KEY, IPerson, adapts=(IPrincipal,))

class Person(AnnotationsMapper):
    implements(IPerson)

    KEY = KEY

    fullname = MappingFieldProperty(IPerson['fullname'])
    email = MappingFieldProperty(IPerson['email'])
    

@adapter(IPrincipalInfo)
@implementer(IAnnotations)
def annotationsForPrincipalInfo(info, context=None):
    utility = getUtility(IPrincipalAnnotationUtility, context=context)
    return utility.getAnnotationsById(info.id)
    
@adapter(IInternalPrincipal)
@implementer(IAnnotations)
def annotationsForInternalPrincipal(iprincipal, context=None):
    utility = getUtility(IPrincipalAnnotationUtility, context=context)
    uid = getParent(iprincipal).prefix + iprincipal.__name__
    return utility.getAnnotationsById(uid)
    
