#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2007-2008 Gregor Giesen <vogon@zaehlwerk.net>             #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'

from zw.vogon.i18n import MessageFactory as _

from zope.component import getUtility
from zope.interface import alsoProvides
from zope.schema import vocabulary
from zope.schema.interfaces import IVocabularyFactory

from zw.vogon.principal.interfaces import IUserFolder

def internalPrincipals(context):
    users = getUtility(IUserFolder, name='users', context=context)
    #groups = getUtility(IGroupFolder, name='group', context=context)
    
    return vocabulary.SimpleVocabulary(
        [ vocabulary.SimpleTerm(
                'users_'+k, 'users_'+k.encode('base64').strip(), v.title ) for \
              k, v in users.items() ] )

alsoProvides(internalPrincipals, IVocabularyFactory)
