#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2007-2008 Gregor Giesen <vogon@zaehlwerk.net>             #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'

from zw.vogon.i18n import MessageFactory as _

from zope.cachedescriptors.property import Lazy
from zope.component import adapts
from zope.interface import implements, Interface

from z3c.form import field, form

from zw.vogon.question.interfaces import IQuestion, IQuestionContainer
from zw.vogon.question.browser.question_form import QuestionForm, \
    AddQuestionForm, ManageQuestionForm
from zw.vogon.question.browser.interfaces import IItemGroupForm, \
    IManageItemGroupForm

from zw.vogon.question.choice.browser.interfaces import IChoiceQuestionForm, \
    IManageChoiceQuestionForm, IAddChoiceQuestionForm
from zw.vogon.question.choice.interfaces import IChoiceQuestion


class ChoiceQuestionForm(QuestionForm):
    implements(IChoiceQuestionForm)
    adapts(IChoiceQuestion, Interface, IItemGroupForm)

    @Lazy
    def fields(self):
        if self.context.other_option:
            return super(ChoiceQuestionForm, self).fields
        else:
            return super(ChoiceQuestionForm, self).fields.omit('other')

    def update(self):
        super(ChoiceQuestionForm, self).update()
        
        #if self.context.other_option:
        #    print self.widgets['other'].id


class ManageChoiceQuestionForm(ManageQuestionForm):
    implements(IChoiceQuestionForm, IManageChoiceQuestionForm)
    adapts(IChoiceQuestion, Interface, IManageItemGroupForm)

    @Lazy 
    def fields(self):
        if self.editing:
            return field.Fields(IQuestion, IChoiceQuestion).omit(
                '__name__', '__parent__')
        if self.context.other_option:
            return super(ManageChoiceQuestionForm, self).fields
        else:
            return super(ManageChoiceQuestionForm, self).fields.omit('other')

    def update(self):
        super(ManageChoiceQuestionForm, self).update()
        
        #if self.context.other_option:
        #    print self.widgets['other'].id


class AddChoiceQuestionForm(AddQuestionForm):
    implements(IAddChoiceQuestionForm)
    adapts(IQuestionContainer, Interface, IManageItemGroupForm)
    

    factory_name = u'zw.vogon.question.ChoiceQuestion'
    fields = field.Fields(IQuestion, IChoiceQuestion).omit(
        '__name__', '__parent__' )
