#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2007-2008 Gregor Giesen <vogon@zaehlwerk.net>             #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'


from zw.vogon.i18n import MessageFactory as _


from zope.component import adapts
from zope.interface import implements
import zope.schema
import zope.schema.interfaces


from z3c.form.browser import widget, select, radio
from z3c.form.converter import CollectionSequenceDataConverter
from z3c.form.interfaces import IDataConverter

from zw.vogon.question.choice.field import IMultipleChoiceQuestionField
from zw.vogon.question.choice.browser.widgets.interfaces import \
    ISelectQuestionWidget, ICheckboxQuestionWidget


class MultipleChoiceQuestionConverter(CollectionSequenceDataConverter):
    adapts(IMultipleChoiceQuestionField, ICheckboxQuestionWidget)
    implements(IDataConverter)

    def toWidgetValue(self, value):
        """Convert from Python bool to HTML representation."""
        widget = self.widget
        if widget.terms is None:
            widget.updateTerms()
        if value is None:
            value = ()
        return [widget.terms.getTerm(entry).token for entry in value]
