#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2008 Gregor Giesen <vogon@zaehlwerk.net>                  #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'

from zw.vogon.i18n import MessageFactory as _

from zope import schema
from zope.interface import Interface

class IChoiceQuestionResults(Interface):
    """Computes some values for ChoiceQuestions.
    """

    baseOptionsMapping = schema.Tuple(
        title = u"A ordered mapping of the predefined options",
        value_type = schema.Dict(
            title = u"Option details",
            description = u"""{ 
               'label':    label option,
               'absolute': absolute number of answers,
               'relative': relative number of answers, }""",
            ) )
        
    extraOptions = schema.Tuple(
        title = u"A ordered mapping of the extra options",
        value_type = schema.Dict(
            title = u"Option details",
            description = u"""{ 
               'label':    label option,
               'absolute': absolute number of answers,
               'relative': relative number of answers, }""",
            ) )

    optionsMapping = schema.Tuple(
        title = u"A ordered mapping of the options with extra options",
        value_type = schema.Dict(
            title = u"Option details",
            description = u"""{ 
               'label':    label option,
               'absolute': absolute number of answers,
               'relative': relative number of answers, 
               'base': True if base option }""",
            ) )



class IChoiceResultSettings(Interface):
    """Results settings specify some preferences for generating results
    of choice questions.
    """

    discard_empty_options = schema.Bool(
        title = _( u'label-question-choice-results.IChoiceResultsSettings-discard_empty_options',
                   u"Discard options without results" ),
        default = False )

    
