#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2008-2009 Gregor Giesen <vogon@zaehlwerk.net>             #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'


from zw.vogon.i18n import MessageFactory as _

from zope.component import adapter

from zw.vogon.participant.interfaces import IParticipant, \
    IParticipantActiveEvent, IParticipantResetEvent
from zw.vogon.question.interfaces import IQuestionContainer, \
    IResponsable, IResponseFolder

def createBlankResponseFor(participant, question):
    if IQuestionContainer.providedBy(question):
        for q in question.values():
            createBlankResponseFor(participant, q)
    
    if IResponsable.providedBy(question):
        rFolder = IResponseFolder(question)
        rFolder.createBlankResponseFor(participant)


@adapter(IParticipant, IParticipantActiveEvent)
def createBlankResponses(participant, event):
    survey = event.survey
    
    for sheet in survey.values():
        createBlankResponseFor(participant, sheet)
        
def removeResponseFor(participant, question):
    if IQuestionContainer.providedBy(question):
        for q in question.values():
            removeResponseFor(participant, q)

    if IResponsable.providedBy(question):
        rFolder = IResponseFolder(question)
        try:
            del rFolder[participant.uid]
        except KeyError:
            pass
    
                
@adapter(IParticipant, IParticipantResetEvent)
def removeResponses(participant, event):
    survey = event.survey
    
    for sheet in survey.values():
        removeResponseFor(participant, sheet)
