#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2007-2008 Gregor Giesen <vogon@zaehlwerk.net>             #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'

from zw.vogon.i18n import MessageFactory as _

from zope.component import adapts
from zope.interface import Interface, implements

from z3c.form import field, form

from zw.vogon.question.interfaces import IQuestionContainer
from zw.vogon.question.browser.form import ItemGroupForm, \
    ManageItemGroupForm, AddItemForm
from zw.vogon.question.browser.interfaces import IItemGroupForm, \
    IManageItemGroupForm

from zw.vogon.question.group.interfaces import IQuestionGroup
from zw.vogon.question.group.browser.interfaces import IQuestionGroupForm, \
    IManageQuestionGroupForm, IAddQuestionGroupForm


class QuestionGroupForm(ItemGroupForm):
    implements(IQuestionGroupForm)
    adapts(IQuestionGroup, Interface, IItemGroupForm)

    fields = field.Fields(IQuestionGroup).omit('__name__', '__parent__')

class ManageQuestionGroupForm(QuestionGroupForm, ManageItemGroupForm):
    implements(IManageQuestionGroupForm)
    adapts(IQuestionGroup, Interface, IManageItemGroupForm)
    form.extends(QuestionGroupForm, ManageItemGroupForm)

    def update(self):
        super(ManageQuestionGroupForm, self).update()
        
        self.itemActions = [ item for name, item in self.actions.items()
                             if name in self.buttons.omit('save', 'cancel_edit').keys() ]
        self.groupActions = [ item for name, item in self.actions.items()
                              if name not in self.buttons.omit('save', 'cancel_edit').keys() ]



class AddQuestionGroupForm(AddItemForm):
    implements(IAddQuestionGroupForm)
    adapts(IQuestionContainer, Interface, IManageItemGroupForm)
    

    factory_name = u'zw.vogon.question.QuestionGroup'
    fields = field.Fields(IQuestionGroup).omit('__name__', '__parent__' )
