#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2007-2008 Gregor Giesen <vogon@zaehlwerk.net>             #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'


from zw.vogon.i18n import MessageFactory as _

from zope import schema
from zope.interface import Interface

from zope.app.container.constraints import containers, contains
from zope.app.container.interfaces import IContained


class IQuestionGroup(IContained):
    """A general container of IGroupItems.
    """
    containers('zw.vogon.question.interfaces.IQuestionContainer')

    title = schema.TextLine(
        title = _( u'label-question.group.IQuestionGroup.title',
                   u"Title" ),
        description = _( u'help-question.group.IQuestionGroup.title',
                         u"A heading for this group" ),
        required = True )

    description = schema.Text(
        title = _( u'label-question.group.IQuestionGroup.description',
                   u"Description" ),
        description = _( u'help-question.group.IQuestionGroup.description',
                         u"A facility to give some comments on this group "
                         u"to appear under the heading." ),
        required = False )

