#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2008 Gregor Giesen <vogon@zaehlwerk.net>                  #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'

from zw.vogon.i18n import MessageFactory as _

from StringIO import StringIO

from zope.component import getMultiAdapter
from zope.component.interfaces import ComponentLookupError

from z3c.pagelet.browser import BrowserPagelet
from zw.vogon.question.results.latex import cleanSRC
from zw.vogon.question.results.renderer import HTMLResultRenderer, \
    LaTeXResultRenderer, XLSResultRenderer


class QuestionGroupResultsPage(HTMLResultRenderer, BrowserPagelet):
    pass


class QuestionGroupResultsTeX(LaTeXResultRenderer):


    def render(self):
        self.update()

        texsrc = StringIO()
        
        print >> texsrc, \
            u"\\noindent\\textbf{\\large %s %s}\\smallskip\\hrule\\medskip" % ( self.index, cleanSRC(self.context.title) )

        for item in self.subviews:
            print >> texsrc, item.render()

        print >> texsrc, u"\\medskip"

        return texsrc.getvalue()


class QuestionGroupResultsXLS(XLSResultRenderer):

    ws = None
    col = 0
    response_mapping = {}
    indices = []

    def update(self):

        c_skipped = 0
        for index, item in enumerate(self.context.values()):
            try:
                view = getMultiAdapter( (item, self.request),
                                        name = self.viewname )
            except ComponentLookupError:
                continue
            view.col = self.col
            view.ws = self.ws
            view.response_mapping = self.response_mapping
            view.indices = self.indices + [index-c_skipped]
            if view.skip_indexing:
                c_skipped += 1
            view.update()
            self.col = view.col
            

    def render(self):
        self.update()
        return self.wb
