#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2007-2008 Gregor Giesen <vogon@zaehlwerk.net>             #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'

from zw.vogon.i18n import MessageFactory as _

from persistent import Persistent
from zope.component import adapter
from zope.event import notify
from zope.interface import implements
from zope.lifecycleevent import ObjectModifiedEvent
from zope.lifecycleevent.interfaces import IObjectModifiedEvent
from zope.location import Location
from zope.schema.fieldproperty import FieldProperty
from zope.schema.vocabulary import SimpleTerm
from zope.traversing.api import getParent
from zope.app.container.contained import Contained

from zw.vogon.question.rating.interfaces import IRatingOption, IRatingOptionTerm

class RatingOption(Contained, Persistent):
    implements(IRatingOption)

    value = FieldProperty(IRatingOption['value'])
    label = FieldProperty(IRatingOption['label'])
    color = FieldProperty(IRatingOption['color'])

    def __init__(self, *args, **kwargs):
        for name, value in kwargs.items():
            setattr(self, name, value)
        
    def __cmp__(self, other):
        return cmp(self.value, other.value)


class RatingOptionList(Location, list):
    pass


class RatingOptionTerm(object):
    implements(IRatingOptionTerm)

    def __init__(self, arg, **kwargs):
        if IRatingOption.providedBy(arg):
            self.value = arg.value
            self.label = kwargs.pop('label', arg.label)
            self.color = kwargs.pop('color', arg.color)
            self.extra_term = kwargs.pop('extra_term', False)
        else:
            self.value = arg
            self.label = kwargs.pop('label')
            self.color = kwargs.pop('color')
            self.extra_term = kwargs.pop('extra_term', False)

        self.token = str(kwargs.pop('token', self.value))

