#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2007-2008 Gregor Giesen <vogon@zaehlwerk.net>             #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'

from zw.vogon.i18n import MessageFactory as _

from zope.cachedescriptors.property import Lazy
from zope.component import adapts
from zope.interface import implements, Interface

from z3c.form import field, form

from zw.vogon.question.interfaces import IQuestion, IQuestionContainer
from zw.vogon.question.browser.form import ItemForm, AddItemForm, \
    ManageItemForm
from zw.vogon.question.browser.interfaces import IItemGroupForm, \
    IManageItemGroupForm

from zw.vogon.question.remark.browser.interfaces import IRemarkForm, \
    IManageRemarkForm, IAddRemarkForm
from zw.vogon.question.remark.interfaces import IRemark


class RemarkForm(ItemForm):
    implements(IRemarkForm)
    adapts(IRemark, Interface, IItemGroupForm)

    @Lazy
    def skip_indexing(self):
        return not self.context.index

class ManageRemarkForm(ManageItemForm):
    implements(IRemarkForm, IManageRemarkForm)
    adapts(IRemark, Interface, IManageItemGroupForm)

    fields = field.Fields(IRemark)

    @Lazy
    def skip_indexing(self):
        return not self.context.index


class AddRemarkForm(AddItemForm):
    implements(IAddRemarkForm)
    adapts(IQuestionContainer, Interface, IManageItemGroupForm)

    factory_name = u'zw.vogon.question.Remark'
    fields = field.Fields(IRemark)
