#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2007-2008 Gregor Giesen <vogon@zaehlwerk.net>             #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'


from zw.vogon.i18n import MessageFactory as _

from zope import schema
from zope.interface import Interface

from zw.schema.richtext import RichText

class IRemark(Interface):
    """A remark on a question sheet.
    """

    remark = RichText(
        title = _( u'label-question.remark.IRemark.remark',
                   u"Remark" ),
        description = _( u'help-question.remark.IRemark.remark',
                         u"Enter the HTML text of a remark to appear "
                         u"on this sheet." ),
        required = True )


    index = schema.Bool(
        title = _( u'label-question.remark.IRemark.index',
                   u"Index this remark" ),
        description = _( u'help-question.remark.IRemark.index',
                         u"If selected the remark will get an index number." ),
        default = False )
        
