#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2008 Gregor Giesen <vogon@zaehlwerk.net>                  #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'


from zw.vogon.i18n import MessageFactory as _

from zope.cachedescriptors.property import Lazy
from zope.component import adapts
from zope.interface import implements

from zw.vogon.question.interfaces import IResponseFolder
from zw.vogon.question.results.interfaces import IQuestionResults

class QuestionResults(object):
    implements(IQuestionResults)

    _response_folder = None

    def __init__(self, question):
        self.__parent__ = self.question = question
        self._response_folder = IResponseFolder(question)

    @Lazy
    def _core_responses(self):
        """Access to this attribute requires special permissions.
        """
        return self._response_folder.values()

    @Lazy
    def count(self):
        return len( [ 1 for r in self._response_folder.values() if r.response is not None ] )

    @Lazy
    def numberOfSkipped(self):
        # raise NotImplementedError
        return 0

    
    
