#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2007-2008 Gregor Giesen <vogon@zaehlwerk.net>             #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'

from zw.vogon.i18n import MessageFactory as _

from zope.interface import Attribute, Interface

from z3c.form import button

class ISheetFrame(Interface):
    """A sheet frame wraps prev/next actions stuff around a sheet and
    displays it inside.
    """

    sheet = Attribute( u"The adapts the view of the actual sheet." )

class IManageSheetFrame(Interface):
    """Extends an ISheetFrame with manage capabilities
    """

class ISheetForm(Interface):
    """A form showing each question of the sheet.
    """

class IManageSheetForm(Interface):
    """Manage a sheet.
    """


class IManageSheetButtons(Interface):

    add_sheet = button.ImageButton(
        title = _( u'Add sheet' ),
        image = u'zw.contentsform/add.png',
        condition = lambda form: not ( form.editing or form.delete ) )
    left = button.ImageButton(
        title = _( u'Left' ),
        image = u'zw.contentsform/leftjust.png',
        condition = lambda form: not (form.editing or form.delete) )
    right = button.ImageButton(
        title = _( u'Right' ),
        image = u'zw.contentsform/rightjust.png',
        condition = lambda form: not (form.editing or form.delete) )

