#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2007-2008 Gregor Giesen <vogon@zaehlwerk.net>             #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'

from zw.vogon.i18n import MessageFactory as _

from zope.cachedescriptors.property import Lazy
from zope.interface import implements

from z3c.batching import batch
from z3c.form import button, field
from z3c.formui import form

from zw.contentsform.adding import AddingFormMixin
from zw.contentsform.column import FieldColumn, FormActionsColumn, Columns
from zw.contentsform.contentsform import OrderableContentsForm
from zw.contentsform.cutcopypaste import CutCopyPasteMixin

from zw.vogon.question.sheet.interfaces import ISheet

class ManageSheets(AddingFormMixin, CutCopyPasteMixin, 
                   OrderableContentsForm):
    form.extends(AddingFormMixin, CutCopyPasteMixin)

    cssClasses = {'table': 'listing' }

    @property
    def label(self):
        return  _( u'label-question.sheet.browser.ManageTemplates.label',
                   u"${title} - Sheets",
                   mapping = {'title': self.context.title } )


    def _getColumns(self):
        return Columns(
            FieldColumn( ISheet['title'], action=u"contents.html" ),
            FormActionsColumn(),
            )
            


