#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2008 Gregor Giesen <vogon@zaehlwerk.net>                  #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'

from zw.vogon.i18n import MessageFactory as _

from StringIO import StringIO

from z3c.pagelet.browser import BrowserPagelet
from zw.vogon.question.results.latex import cleanSRC
from zw.vogon.question.results.renderer import HTMLResultRenderer, \
    LaTeXResultRenderer


class SheetResultsPage(HTMLResultRenderer, BrowserPagelet):
    pass


class SheetResultsTeX(LaTeXResultRenderer):

    def render(self):
        self.update()

        texsrc = StringIO()
        
        print >> texsrc, \
            u"\\begin{multicols}{2}[\\noindent\\textbf{\\large %s %s}\\smallskip\\hrule]" % ( self.index, cleanSRC(self.context.title) )

        for item in self.subviews:
            print >> texsrc, item.render()

        print >> texsrc, u"\\end{multicols}"

        return texsrc.getvalue()

