#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2007-2008 Gregor Giesen <vogon@zaehlwerk.net>             #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'


from zw.vogon.i18n import MessageFactory as _


from zope.component import adapts
from zope.component.factory import Factory
from zope.interface import alsoProvides, implements
from zope.schema import getFieldNames

from zw.vogon.template.interfaces import ITemplateFactory, IClone, IClonable
from zw.vogon.question.sheet.interfaces import ISheet

class SheetFactory(Factory):
    implements(ITemplateFactory)
    adapts(ISheet)
    
    title = _( u"Factory for templating sheets" )
    description = u''
    _interfaces = None

    def __init__(self, template):
        self.template = template
        self._callable = template.__class__

    def __call__(self, *args, **kw):
        item = self._callable( *args, **kw )

        # fill item with values
        for name in getFieldNames(ISheet):
            if name is not '__name__':
                setattr( item, name,   
                         getattr(self.template, name, ISheet[name].default) )
       

        # add template reference
        alsoProvides(item, IClonable)
        clone = IClone(item)
        clone.template = self.template

        return item

    
