#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2007-2008 Gregor Giesen <vogon@zaehlwerk.net>             #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'

from zw.vogon.i18n import MessageFactory as _

from zope.cachedescriptors.property import Lazy
from zope.component import adapts
from zope.interface import implements, Interface

from z3c.form import field, form

from zw.vogon.question.interfaces import IQuestion, IQuestionContainer
from zw.vogon.question.browser.question_form import QuestionForm, \
    AddQuestionForm, ManageQuestionForm
from zw.vogon.question.browser.interfaces import IItemGroupForm, \
    IManageItemGroupForm

from zw.vogon.question.text.browser.interfaces import ITextQuestionForm, \
    IManageTextQuestionForm, IAddTextQuestionForm
from zw.vogon.question.text.interfaces import ITextQuestion


class TextQuestionForm(QuestionForm):
    implements(ITextQuestionForm)
    adapts(ITextQuestion, Interface, IItemGroupForm)

class ManageTextQuestionForm(ManageQuestionForm):
    implements(ITextQuestionForm, IManageTextQuestionForm)
    adapts(ITextQuestion, Interface, IManageItemGroupForm)

    #@Lazy 
    #def fields(self):
    #    if self.editing:
    #        return field.Fields(IQuestion, ITextQuestion).omit(
    #            '__name__', '__parent__')
    #    return super(ManageQuestionForm, self).fields


class AddTextQuestionForm(AddQuestionForm):
    implements(IAddTextQuestionForm)
    adapts(IQuestionContainer, Interface, IManageItemGroupForm)
    

    factory_name = u'zw.vogon.question.TextQuestion'
    fields = field.Fields(IQuestion, ITextQuestion).omit(
        '__name__', '__parent__' )
