#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2007-2008 Gregor Giesen <vogon@zaehlwerk.net>             #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'


from zw.vogon.i18n import MessageFactory as _

from zope.component import adapter
from zope.interface import implementer, implementsOnly

from z3c.form.browser import widget
from z3c.form.interfaces import IFormLayer, IFieldWidget
from z3c.form.widget import FieldWidget, Widget

from zw.vogon.question.text.field import ITextQuestionField
from zw.vogon.question.text.browser.widgets.interfaces import \
    ITextQuestionWidget, ITextLineQuestionWidget


class TextQuestionWidget(widget.HTMLTextAreaWidget, Widget):
    """
    """
    implementsOnly(ITextQuestionWidget)

    klass = u'question-text-widget'
    value = u''

    def update(self):
        super(TextQuestionWidget, self).update()
        widget.addFieldClass(self)


class TextLineQuestionWidget(widget.HTMLTextInputWidget, Widget):
    """
    """
    implementsOnly(ITextLineQuestionWidget)

    klass = u'question-textline-widget'
    value = u''

    def update(self):
        super(TextLineQuestionWidget, self).update()
        widget.addFieldClass(self)


@adapter(ITextQuestionField, IFormLayer)
@implementer(IFieldWidget)
def TextQuestionFieldWidget(field, request):
    """IFieldWidget factory for TextQuestionWidget.
    """
    if field.rows == 1:
        widget = FieldWidget(field, TextLineQuestionWidget(request))
        widget.size = field.cols
    else:
        widget = FieldWidget(field, TextQuestionWidget(request))
        widget.rows = field.rows
        widget.cols = field.cols

    return widget


