#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2007-2008 Gregor Giesen <vogon@zaehlwerk.net>             #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'

from zope import schema
from zope.interface import implements
from zw.vogon.question.field import QuestionField, IQuestionField

class ITextQuestionField(IQuestionField):
    """Field to store the answer to a text question.
    In contrast to zope.schema.IText this field also supports
    to specify the numbers of cols and rows for the widget.
    """


class TextQuestionField(schema.Text, QuestionField):
    implements(ITextQuestionField)
    
    def __init__(self, rows=5, cols=60, **kw):
        self.rows = rows
        self.cols = cols
        super(TextQuestionField, self).__init__(**kw)
