#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2007-2008 Gregor Giesen <vogon@zaehlwerk.net>             #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'


from zw.vogon.i18n import MessageFactory as _

from zope import schema
from zope.interface import Interface

from zw.vogon.question.interfaces import IResponsable, \
    IResponseSchema, IQuestionField
from zw.vogon.question.text.field import TextQuestionField

class ITextQuestion(Interface):
    """A text question.
    """

    rows = schema.Int(
        title = _( u'label-question.text.ITextQuestion.rows',
                   u"Number of lines for response field" ),
        description = _( u'help-question.text.ITextQuestion.rows',
                         u"This field let you specify the number "
                         u"of lines of the answer widget." ),
        required = True,
        min = 1,
        max = 100,
        default = 10 )

    cols = schema.Int(
        title = _( u'label-question.text.ITextQuestion.cols',
                   u"Number of columns for response field" ),
        description = _( u'help-question.text.ITextQuestion.cols',
                         u"This field let you specify the number "
                         u"of columns of the answer widget." ),
        required = True,
        min = 20,
        max = 80,
        default = 60 )


class ITextResponseSchema(IResponseSchema):
    """
    """

    response = TextQuestionField( title = u'Response' )

