#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2008 Gregor Giesen <vogon@zaehlwerk.net>                  #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'


from zw.vogon.i18n import MessageFactory as _

from zope import schema
from zope.interface import Interface

from zw.vogon.question.results.interfaces import IResultSettings


class ITextResults(Interface):
    """Results of a text question.
    """

    uniqueResponses = schema.Set(
        title = u"List of unique responses, equal ones are merged.",
        value_type = schema.TextLine(
            title=u"Response text" ),
        )

    countOfResponses = schema.Dict(
        title = u"Dict of response keys and count values",
        key_type = schema.TextLine( title=u"Response text" ),
        value_type = schema.Int( title=u"Count" ),
        )
        

class ITextResultSettings(IResultSettings):
    """Results settings specify some preferences for generating results
    of text questions.
    """

    join_equal = schema.Bool(
        title = _( u'label-question.results.ITextResultsSettings.join_equal',
                   u"Join equal responses" ),
        description = _( u'help-question.results.ITextResultsSettings.join_equal',
                         u"If checked, the results renderer will count and join equal responses." ),
        default = True )

    
