#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2008 Gregor Giesen <vogon@zaehlwerk.net>                  #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'

from zw.vogon.i18n import MessageFactory as _

from zope.cachedescriptors.property import Lazy
from zope.component import adapts
from zope.interface import Interface
from zope.security.proxy import removeSecurityProxy
from z3c.breadcrumb.browser import GenericBreadcrumb
from z3c.form import field
from z3c.formui import form
from z3c.pagelet.browser import BrowserPagelet

from zw.vogon.settings.interfaces import ISettings

class EditSettings(form.EditForm):
    """Configlet view
    """

    @property
    def label(self):
        return self.context.__title__

    @property
    def description(self):
        return self.context.__description__

    @Lazy
    def fields(self):
        return field.Fields( 
            removeSecurityProxy(self.context.__schema__) )
    

class SettingsRootPage(BrowserPagelet):
    pass


class SettingsBreadcrumb(GenericBreadcrumb):
    adapts(ISettings, Interface)

    @property
    def name(self):
        return self.context.__title__ or self.context.__name__
