#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2007-2008 Gregor Giesen <giesen@zaehlwerk.net>            #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""zw.vogon.settings Test module
$Id$
"""
__docformat__ = 'reStructuredText'

import doctest
import unittest

import zope.component.testing
import zope.component.eventtesting
from zope.app.component.hooks import setHooks
from zope.testing.doctestunit import DocFileSuite

from zw.vogon.settings import events

def setUp(test):
    zope.component.testing.setUp(test)
    zope.component.eventtesting.setUp(test)
    setHooks()

def test_suite():
    return unittest.TestSuite((
        DocFileSuite(
                'README.txt',
                package='zw.vogon.settings',
                setUp=setUp, tearDown=zope.component.testing.tearDown,
                optionflags = doctest.NORMALIZE_WHITESPACE|doctest.ELLIPSIS,
                ),
        ))

if __name__ == '__main__':
    unittest.main(defaultTest='test_suite')
