#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2007-2008 Gregor Giesen <vogon@zaehlwerk.net>             #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'

from zw.vogon.i18n import MessageFactory as _

from z3c.form import field, subform
from z3c.formui import form

from zw.vogon.survey.interfaces import IInvitationText, IReminderText

class InvitationTextSubForm(subform.EditSubForm):
    fields = field.Fields(IInvitationText)
    prefix = 'invitation'

    label = _( u'Invitation text' )

class ReminderTextSubForm(subform.EditSubForm):
    fields = field.Fields(IReminderText)
    prefix = 'reminder'
    
    label = _( u'Reminder text' )
    

class MailTextsForm(form.EditForm):

    @property
    def label(self):
        return self.context.title


    def update(self):
        super(MailTextsForm, self).update()

        invitation = InvitationTextSubForm(self.context, self.request, self)
        invitation.update()
        self.invitation =  invitation

        reminder = ReminderTextSubForm(self.context, self.request, self)
        reminder.update()
        self.reminder = reminder
        
        
