#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2007-2008 Gregor Giesen <vogon@zaehlwerk.net>             #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'

from zw.vogon.i18n import MessageFactory as _

from zope.component import adapter, createObject
from zope.component.interfaces import ObjectEvent
from zope.event import notify
from zope.interface import alsoProvides, implements
from zope.lifecycleevent import ObjectCreatedEvent
from zope.app.container.contained import ObjectAddedEvent

from zw.vogon.survey.interfaces import ISurveyFolder, ISurveyArchive, \
    ISurveyFinishedEvent
from zw.vogon.portal.interfaces import INewPortalEvent


##############################################################################
# setup new Folders on evaluation unit creation

@adapter(INewPortalEvent)
def setUpSurveyFolder(event):
    portal = event.object
    sm = portal.getSiteManager()

    surveys = createObject( u'zw.vogon.survey.SurveyFolder' )
    notify( ObjectCreatedEvent(surveys) )
    portal['surveys'] = surveys
    notify( ObjectAddedEvent(surveys) )
    sm.registerUtility( surveys, ISurveyFolder, name=u"Surveys" )

    archive = createObject( u'zw.vogon.survey.SurveyFolder' )
    alsoProvides(archive, ISurveyArchive)
    archive.title = u'Archive'
    notify( ObjectCreatedEvent(archive) )
    surveys['archive'] = archive
    notify( ObjectAddedEvent(archive) )
    sm.registerUtility( archive, ISurveyArchive )

class SurveyFinishedEvent(ObjectEvent):
    implements(ISurveyFinishedEvent)

    def __init__(self, survey, principal):
        super(SurveyFinishedEvent, self).__init__(survey)
        self.survey = survey
        self.principal = principal
