#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2007-2008 Gregor Giesen <vogon@zaehlwerk.net>             #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'

from zw.vogon.i18n import MessageFactory as _

from zope.cachedescriptors.property import Lazy
from zope.dublincore.interfaces import IZopeDublinCore
from z3c.form import button, form

from zw.contentsform.adding import AddingFormMixin
from zw.contentsform.column import FieldColumn, ContentNameColumn, Columns, \
    FormActionsColumn
from zw.contentsform.contentsform import OrderableContentsForm
from zw.contentsform.cutcopypaste import CutCopyPasteMixin, RenamableMixin

from zw.vogon.template.interfaces import ISurveyAttributeTemplate, \
    ISurveyAttributeTemplates

class SurveyAttributeTemplateForm(AddingFormMixin, CutCopyPasteMixin, 
                                  RenamableMixin, OrderableContentsForm):
    form.extends(AddingFormMixin, CutCopyPasteMixin, RenamableMixin)

    label = _( u'label-template.browser.AttributeForm.label',
               u"Survey attribute templates" )

    cssClasses = {'table': 'listing' }

    @Lazy
    def container(self):
        return ISurveyAttributeTemplates(self.context)
    

    def _getColumns(self):
        return Columns(
            ContentNameColumn( title=u'Unique name' ),
            FieldColumn( ISurveyAttributeTemplate['title'] ),
            FieldColumn( ISurveyAttributeTemplate['description'] ),
            FieldColumn( ISurveyAttributeTemplate['public'] ),
            FieldColumn( ISurveyAttributeTemplate['required'] ),
            FieldColumn( ISurveyAttributeTemplate['readonly'] ),
            FieldColumn( ISurveyAttributeTemplate['default'] ),
            #FormActionsColumn() # XXX 
            )
            
    @button.buttonAndHandler( _( u'Add', ), name='add_new',
                              condition = lambda form: \
                                  form.session.get('add') is None )
    def handleAddNew(self, action):
        self.session['add'] = u'zw.vogon.template.SurveyAttributeTemplate'
        self.request.response.redirect(self.request.getURL())

