#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2007-2008 Gregor Giesen <vogon@zaehlwerk.net>             #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'

from zw.vogon.i18n import MessageFactory as _

from zope.cachedescriptors.property import Lazy
from zope.component import queryUtility
from zope.traversing.browser import absoluteURL
from zope.viewlet import viewlet

from zw.vogon.browser import checkViewAccess
from zw.vogon.browser.breadcrumbs import IVogonBreadcrumb
from zw.vogon.survey.interfaces import ISurveyFolder, ITemplateFolder
from zw.vogon.utils.normalizer.interfaces import IIDNormalizer


class SurveysNavigation(viewlet.simple, viewlet.ViewletBase):

    @Lazy
    def root_folder(self):
        return queryUtility(ISurveyFolder, name=u"Surveys", default=None)

    def count(self):
        return 0

    def folders(self):
        if self.root_folder is None:
            return []
        return [ {
                'title': item.title,
                'description': u'',
                'selected': u'',
                'url': absoluteURL( item, self.request ), 
                } for item in self.root_folder.values() \
                if ISurveyFolder.providedBy(item) ]

class TemplatesNavigation(viewlet.simple, viewlet.ViewletBase):

    @Lazy
    def root_folder(self):
        return queryUtility(ITemplateFolder, name=u"Templates", default=None)


    def count(self):
        return 0

    
    def folders(self):
        if self.root_folder is None:
            return []
        return [ {
                'title': item.title,
                'description': u'',
                'selected': u'',
                'url': absoluteURL( item, self.request ), 
                } for item in self.root_folder.values() \
                if ITemplateFolder.providedBy(item) ]
