#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2008 Gregor Giesen <vogon@zaehlwerk.net>                  #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'

from zw.vogon.i18n import MessageFactory as _

from zope.dublincore.interfaces import IZopeDublinCore
from z3c.form import form

from zw.contentsform.adding import AddingFormMixin
from zw.contentsform.column import FieldColumn, Columns
from zw.contentsform.contentsform import ContentsForm
from zw.contentsform.cutcopypaste import CutCopyPasteMixin

from zw.vogon.template.interfaces import ISurveyTemplate, ITemplateFolder

class ManageTemplatesForm(AddingFormMixin, CutCopyPasteMixin, ContentsForm):
    form.extends(AddingFormMixin, CutCopyPasteMixin)

    label = _( u'label-template.browser.manage_tempaltes.ManageTemplates.label',
               u"Templates overview" )

    cssClasses = {'table': 'listing' }

    def getContents(self):
        ### Add Templatefolder ?
        return [ item for item in self.context.values() \
                     if ISurveyTemplate.providedBy(item) ]
    

    def _getColumns(self):
        return Columns(
            FieldColumn( ISurveyTemplate['title'], action='overview.html' ),
            FieldColumn( IZopeDublinCore['created'], addable=False ),
            FieldColumn( IZopeDublinCore['modified'], addable=False ),
            )
            
