#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2007-2008 Gregor Giesen <giesen@zaehlwerk.net>            #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'

from zw.vogon.i18n import MessageFactory as _
from zw.vogon.i18n import to_unicode

from zope.dublincore.interfaces import IWriteZopeDublinCore


def updateDCInfos(context, event):
    """Update a object's Dublin Core Title and Description 
    property with its name.
    """
    dc = IWriteZopeDublinCore(context)
    dc.title = to_unicode( getattr(context, 'title',
                                   getattr( context, '__name__', u'' ) ) or u'' )
    dc.description = to_unicode( getattr(context, 'description', u'' ) or u'' )
    
