#-*- coding: utf-8 -*-
#############################################################################
#                                                                           #
#   Copyright (c) 2007-2008 Gregor Giesen <vogon@zaehlwerk.net>             #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 3 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                           #
#############################################################################
"""
$Id$
"""
__docformat__ = 'reStructuredText'

from zw.vogon.i18n import MessageFactory as _

from zope.component import adapts, getUtility
from zope.dublincore.interfaces import IZopeDublinCore
from zope.app.container.contained import NameChooser as BaseNameChooser
from zope.app.container.interfaces import IContainer

from plone.i18n.normalizer.interfaces import IURLNormalizer


class NameChooser(BaseNameChooser):
    adapts(IContainer)

    def chooseName(self, name, object):
        normalizer = getUtility(IURLNormalizer)

        if not name:
            name = getattr(object, 'title', None)
        if not name:
            try:
                dc = IZopeDublinCore(object)
            except:
                pass
            else:
                name = dc.title or None
        if not name:
            name = object.__class__.__name__

        return super(NameChooser, self).chooseName(
            normalizer.normalize(name), object )
        
